Subject: Re: bug#76234: [PATCH] Prefix argument implies recursive for project-remember/forget-under

From: Dmitry Gutov <[email-masked]>
Date: Fri, 14 Feb 2025 05:58:38 +0200

On 13/02/2025 09:28, Eli Zaretskii wrote:

>> Check this out:
>> https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=6077bbfc3d4a4aa042b364d31dd681e9f7ab7f30
> 
> IMO, this:
> 
>    +Display a message at the end summarizing what was found.
>    +Return the number of detected projects."
> 
> contrasts strangely with this:
> 
>    +Display a message at the end summarizing what was forgotten.
>    +Return the number of forgotten projects."
> 
> If we say "forgotten" in the latter case, why do we say "found" (and
> not, for example, "remembered" or "new" or "added") in the former?
> Doesn't the latter case also "find" projects?

It wouldn't include the project that were found in the second scan but 
weren't "known" previously.

Probably a minor distinction, but that's my reasoning for this anyway.

Perhaps we could change it from "number of forgotten project" to "number 
of projects we forgot"? Subtle difference.

> That's one reason why in my proposal I used "indexed".
> 
> Also, this:
> 
>    Remember projects below a directory DIR.
> 
> is in contrast with this:
> 
>    Forget all known projects below a directory DIR.
> 
> Why doesn't the former say "all the projects", but the latter does?

Good question, I think the latter should not have "all" as well. I think 
"all" implies the recursive search, at least in some readings.

> And a final nit: should we somehow explain in the doc string what it
> means to "remember" and to "forget" in this context?

Not sure, but we could say that it means adding to and removing from the 
"known projects list".